﻿
namespace TaskGenerater
{
    public static class Templete
    {
        public static string MergeFile(string classString)
        {
            return FileTemplate.Trim()
                .Replace("{class}", classString);
        }

        public static string MergeClass(Generater data)
        {
            return Templete.ClassTemplete.Trim()
                .Replace("{namespace}", data.Namespace)
                .Replace("{clientName}", data.ClientName)
                .Replace("{methods}", data.MethodsString);
        }

        public static string MergeMethod(dynamic data)
        {
            return Templete.MethodTemplete.Trim()
                .Replace("{returnType}", data.ReturnType)
                .Replace("{methodName}", data.MethodName)
                .Replace("{paramsTypeAndNames}", data.ParamsTypeAndNames)
                .Replace("{beginMethod}", data.BeginMethod)
                .Replace("{endMethod}", data.EndMethod)
                .Replace("{paramsNames}", data.ParamsNames);
        }

        #region 模版

        public const string FileTemplate = @"

using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.Threading.Tasks;
using System.Collections.ObjectModel;

{class}

";


        public const string ClassTemplete = @"

namespace {namespace}
{
    public partial class {clientName} 
    {
        {methods}
    }
}


";

        public const string MethodTemplete = @"

        public Task{returnType} {methodName}({paramsTypeAndNames})
        {
            return Task{returnType}.Factory.FromAsync(this.Channel.{beginMethod}, this.Channel.{endMethod} {paramsNames}, null);
        }

";

        #endregion
    }
}